open StateDataMainType;

open SourceTextureType;

open BasicSourceTextureType;

let createBasicSourceTexture = state =>
  CreateBasicSourceTextureMainService.create(. state);

let unsafeGetBasicSourceTextureSource =
    (texture, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  OperateBasicSourceTextureMainService.unsafeGetSource(texture, state);

let setBasicSourceTextureSource =
    (texture, source, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  OperateBasicSourceTextureMainService.setSource(texture, source, state);

let getBasicSourceTextureWidth = (texture, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  OperateBasicSourceTextureMainService.getWidth(texture, state);

let getBasicSourceTextureHeight = (texture, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  OperateBasicSourceTextureMainService.getHeight(texture, state);

let getBasicSourceTextureWrapS = (texture, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  OperateBasicSourceTextureMainService.getWrapS(texture, state) |> uint8ToWrap;

let setBasicSourceTextureWrapS =
    (texture, wrapS, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  OperateBasicSourceTextureMainService.setWrapS(
    texture,
    wrapS |> wrapToUint8,
    state,
  );

let getBasicSourceTextureWrapT = (texture, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentThouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(TtateDataMain.stateData)
     ); */
  OperateBasicSourceTextureMainService.getWrapT(texture, state) |> uint8ToWrap;

let setBasicSourceTextureWrapT =
    (texture, wrapT, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentThouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(TtateDataMain.stateData)
     ); */
  OperateBasicSourceTextureMainService.setWrapT(
    texture,
    wrapT |> wrapToUint8,
    state,
  );

let getBasicSourceTextureMagFilter = (texture, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  OperateBasicSourceTextureMainService.getMagFilter(texture, state)
  |> uint8ToFilter;

let setBasicSourceTextureMagFilter =
    (texture, filter, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  OperateBasicSourceTextureMainService.setMagFilter(
    texture,
    filter |> filterToUint8,
    state,
  );

let getBasicSourceTextureMinFilter = (texture, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  OperateBasicSourceTextureMainService.getMinFilter(texture, state)
  |> uint8ToFilter;

let setBasicSourceTextureMinFilter =
    (texture, filter, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  OperateBasicSourceTextureMainService.setMinFilter(
    texture,
    filter |> filterToUint8,
    state,
  );

let getBasicSourceTextureFormat = (texture, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  OperateBasicSourceTextureMainService.getFormat(texture, state)
  |> uint8ToFormat;

let setBasicSourceTextureFormat =
    (texture, format, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  OperateBasicSourceTextureMainService.setFormat(
    texture,
    format |> formatToUint8,
    state,
  );

let getBasicSourceTextureType = (texture, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  OperateBasicSourceTextureMainService.getType(texture, state);

let setBasicSourceTextureType =
    (texture, type_, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  OperateBasicSourceTextureMainService.setType(texture, type_, state);

let getBasicSourceTextureFlipY = (texture, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  OperateBasicSourceTextureMainService.getFlipY(texture, state);

let setBasicSourceTextureFlipY =
    (texture, flipY, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  OperateBasicSourceTextureMainService.setFlipY(texture, flipY, state);

let getBasicSourceTextureName = (texture, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  NameBasicSourceTextureMainService.getName(texture, state);

let unsafeGetBasicSourceTextureName =
    (texture, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  NameBasicSourceTextureMainService.unsafeGetName(texture, state);

let setBasicSourceTextureName =
    (texture, name, state: StateDataMainType.state) =>
  /* WonderLog.Contract.requireCheck(
       () =>
         WonderLog.(
           Contract.(
             Operators.(
               AliveComponentService.checkComponentShouldAlive(
                 texture,
                 isAlive,
                 RecordBasicSourceTextureMainService.getRecord(state)
               )
             )
           )
         ),
       IsDebugMainService.getIsDebug(StateDataMain.stateData)
     ); */
  NameBasicSourceTextureMainService.setName(texture, name, state);

let getAllTextures = state => {
  let {index, disposedIndexArray} =
    RecordBasicSourceTextureMainService.getRecord(state);

  GetAllComponentService.getAllComponents(index, disposedIndexArray);
};

let disposeBasicSourceTexture = (texture, isRemoveTexture, state) =>
  DisposeBasicSourceTextureMainService.handleDisposeTexture(
    texture,
    isRemoveTexture,
    state,
  );